import { VerificationError, verify_number, verify_string, verify_boolean, verify_void, strip_number, strip_string, strip_boolean, strip_void } from "./ts_base";
export default class AddValueRequest {
   value1?: number;
   value2?: number;

   constructor(init?:Partial<AddValueRequest>){
      if(init){
         if(init["value1"])
            this.value1 = init["value1"];
         if(init["value2"])
            this.value2 = init["value2"];
      }
   }


   static verify(data: AddValueRequest) {
      verify_AddValueRequest(data);
   }
}

export function strip_AddValueRequest(data: AddValueRequest): AddValueRequest {
   let res = {} as any;
   res["value1"] = strip_number(data["value1"])
   res["value2"] = strip_number(data["value2"])
   return res;
}

export function verify_AddValueRequest(data: AddValueRequest) {
   if(data["value1"] !== null && data["value1"] !== undefined ) {
      if(typeof data["value1"] !== "number") throw new VerificationError("number", "value1", data["value1"]);
   }

   if(data["value2"] !== null && data["value2"] !== undefined ) {
      if(typeof data["value2"] !== "number") throw new VerificationError("number", "value2", data["value2"]);
   }

   return data
}