import { VerificationError, verify_number, verify_string, verify_boolean, verify_void, strip_number, strip_string, strip_boolean, strip_void } from "./ts_base";
export default class AddValueResponse {
   value?: number;

   constructor(init?:Partial<AddValueResponse>){
      if(init){
         if(init["value"])
            this.value = init["value"];
      }
   }


   static verify(data: AddValueResponse) {
      verify_AddValueResponse(data);
   }
}

export function strip_AddValueResponse(data: AddValueResponse): AddValueResponse {
   let res = {} as any;
   res["value"] = strip_number(data["value"])
   return res;
}

export function verify_AddValueResponse(data: AddValueResponse) {
   if(data["value"] !== null && data["value"] !== undefined ) {
      if(typeof data["value"] !== "number") throw new VerificationError("number", "value", data["value"]);
   }

   return data
}