import { VerificationError, verify_number, verify_string, verify_boolean, verify_void, strip_number, strip_string, strip_boolean, strip_void } from "./ts_base";
export default class TestAtom {
   val_number?: number;
   val_boolean?: boolean;
   val_string?: string;

   constructor(init?:Partial<TestAtom>){
      if(init){
         if(init["val_number"])
            this.val_number = init["val_number"];
         if(init["val_boolean"])
            this.val_boolean = init["val_boolean"];
         if(init["val_string"])
            this.val_string = init["val_string"];
      }
   }


   static verify(data: TestAtom) {
      verify_TestAtom(data);
   }
}

export function strip_TestAtom(data: TestAtom): TestAtom {
   let res = {} as any;
   res["val_number"] = strip_number(data["val_number"])
   res["val_boolean"] = strip_boolean(data["val_boolean"])
   res["val_string"] = strip_string(data["val_string"])
   return res;
}

export function verify_TestAtom(data: TestAtom) {
   if(data["val_number"] !== null && data["val_number"] !== undefined ) {
      if(typeof data["val_number"] !== "number") throw new VerificationError("number", "val_number", data["val_number"]);
   }

   if(data["val_boolean"] !== null && data["val_boolean"] !== undefined ) {
      if(typeof data["val_boolean"] !== "boolean") throw new VerificationError("boolean", "val_boolean", data["val_boolean"]);
   }

   if(data["val_string"] !== null && data["val_string"] !== undefined ) {
      if(typeof data["val_string"] !== "string") throw new VerificationError("string", "val_string", data["val_string"]);
   }

   return data
}